//
// MoonCanvas.h
// Draw the moon and related info.
//
//    Copyright 2002 by Akkana Peck.
// You may use or distribute this code under the terms of the GPL.
//

#ifndef MOONCANVAS_H
#define MOONCANVAS_H

#include "SkyCanvas.h"

#include <qstring.h>

#include <sys/time.h>

class QImage;
class MoonFeature;

class MoonCanvas : public SkyCanvas
{
    Q_OBJECT
public:
    MoonCanvas( QWidget *parent=0, const char *name=0 );
    virtual ~MoonCanvas();

    void Init();

    void ToggleMirrored();

    virtual void Paint();

public slots:

signals:

protected:
    int moonRadius;
    int moonCenterX, moonCenterY;
    QImage* moonImg;
    int mMirrored;

    int mCraterNum;
#define MAX_OBJECTS_SHOWN 6
    MoonFeature* mMatches[MAX_OBJECTS_SHOWN];

    // All images have some inherent libration, alas.  Compensate:
    int mImgLibrationE;
    int mImgLibrationN;

    // Save description strings in case we get a chance to show them
    QString mDescriptions;

    // Time of last mouse button down event:
    struct timeval mLastButtonDownTime;

    void PaintFeature(MoonFeature* feature);
    void mousePressEvent(QMouseEvent *event);
    void mouseReleaseEvent(QMouseEvent *event);

    QSize minimumSizeHint() const;
};

#endif // MOONCANVAS_H
